import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.HashSet;
import java.util.List;
import java.util.Set;
import java.util.TreeSet;


public class Rhino {

	private static class Hrac {
		public Karta prvni;
		public Karta druha;

		public String konbinace;

		public Hrac() { }

		@Override
		public String toString() {
			return prvni.toString() + "  " + druha.toString(); 
		}
	}

	private static class Karta implements Comparable<Karta> {
		public char barva;
		public int hodnota;

		public Karta(char barva, int hodnota) {
			this.barva = barva;
			this.hodnota = hodnota;
		}

		@Override
		public int compareTo(Karta arg0) {
			if (this.hodnota == arg0.hodnota) return 1;
			return this.hodnota - arg0.hodnota;
		}

		@Override
		public String toString() {
			return barva + " " + hodnota;
		}

	}

	private static BufferedReader bfr = new BufferedReader(new InputStreamReader(System.in));

	private static String hraci(List<Hrac> hraci, Set<Karta> stul) {
		for (Hrac hrac: hraci) {
			Set<Karta> jedenHrac = new TreeSet<Karta>(stul);
			jedenHrac.add(hrac.prvni);
			jedenHrac.add(hrac.druha);
			System.out.println(vyhodnot(jedenHrac));
		}

		return "";
	}

	private static String vyhodnot(Set<Karta> handa) {
		ArrayList<String> kom = new ArrayList<String>();
		int s = 0; 
		int c = 0; 
		int d = 0; 
		int h = 0;

		ArrayList<Karta> list = new ArrayList<Karta>(handa);
		System.out.println(handa);
		boolean post[] = new boolean[6];
		for(int i=0; i<6; i++) {
			if (list.get(i).hodnota+1 == list.get(i+1).hodnota) {
				post[i] = true;
			} else {
				post[i] = false;
			}
		}

		if (post[2] && post[3]) {
			if (post[1]) {
				if (post[0]) kom.add("s0-4");
				if (post[4]) kom.add("s1-5");
			}
			if (post[4]) {
				if (post[5]) kom.add("s2-6");
			}
		}

		int hodPred = -5;
		int i=0;
		for(Karta k: list) {
			if (k.barva == 's') s++;
			if (k.barva == 'c') c++;
			if (k.barva == 'd') d++;
			if (k.barva == 'h') h++;

			if (hodPred == k.hodnota) {
				kom.add("p"+k.hodnota+"");
			}
			hodPred = k.hodnota;
			i++;
		}

		if (s >= 5) kom.add("bs");
		if (c >= 5) kom.add("bc");
		if (d >= 5) kom.add("bd");
		if (h >= 5) kom.add("bh");

		System.out.println(kom);

		// vyhodnoceni
		String vys = "";

		if (kom.isEmpty()) {
			return "HC_"+list.get(6).hodnota + ","+
					list.get(5).hodnota + ","+
					list.get(4).hodnota + ","+
					list.get(3).hodnota + ","+
					list.get(2).hodnota + ",";
		}

		// pary, dva pary, triple, fullh, poker, flush, straight
		
		if (kom.contains("bs") || kom.contains("bc") || kom.contains("bd") || kom.contains("bh")) {
			if (kom.contains("s0-4")) {
				char barva = list.get(0).barva;
				boolean sf = true;
				for(i=1; i<5; i++) {
					if (list.get(i).barva != barva) {
						sf = false;
						break;
					}
				}
				if (sf) return "SF_"+list.get(4);
			}
			if (kom.contains("s1-5")) {
				char barva = list.get(1).barva;
				boolean sf = true;
				for(i=2; i<6; i++) {
					if (list.get(i).barva != barva) {
						sf = false;
						break;
					}
				}
				if (sf) return "SF_"+list.get(5);
			} 
			if (kom.contains("s2-6")) {
				char barva = list.get(2).barva;
				boolean sf = true;
				for(i=3; i<7; i++) {
					if (list.get(i).barva != barva) {
						sf = false;
						break;
					}
				}
				if (sf) return "SF_"+list.get(6);
			}
		}

		return "";
	}


	public static void main(String[] args) {
		try {
			List<Hrac> setHracu = new ArrayList<Hrac>();
			String linka;
			linka = bfr.readLine();
			int hraci = Integer.parseInt(linka);
			linka = bfr.readLine();
			String ln[] = linka.split(" ");
			Set<Karta> stul = new HashSet<Karta>();
			for(int i=0; i<5; i++) {
				int hodnota;
				if (ln[i].charAt(0) == 'X') hodnota = 10;
				else if (ln[i].charAt(0) == 'J') hodnota = 11;
				else if (ln[i].charAt(0) == 'Q') hodnota = 12;
				else if (ln[i].charAt(0) == 'K') hodnota = 13;
				else if (ln[i].charAt(0) == 'A') hodnota = 14;
				else hodnota = Integer.parseInt(ln[i].charAt(0) + "");
				Karta nova = new Karta(ln[i].charAt(1), hodnota);
				stul.add(nova);
			}
			for (int i=0; i<hraci; i++) {
				Hrac novy = new Hrac();
				linka = bfr.readLine();
				ln = linka.split(" ");
				int hodnota;
				if (ln[0].charAt(0) == 'X') hodnota = 10;
				else if (ln[0].charAt(0) == 'J') hodnota = 11;
				else if (ln[0].charAt(0) == 'Q') hodnota = 12;
				else if (ln[0].charAt(0) == 'K') hodnota = 13;
				else if (ln[0].charAt(0) == 'A') hodnota = 14;
				else hodnota = Integer.parseInt(ln[0].charAt(0) + "");
				Karta nova = new Karta(ln[0].charAt(1), hodnota);
				novy.prvni = nova;

				if (ln[1].charAt(0) == 'X') hodnota = 10;
				else if (ln[1].charAt(0) == 'J') hodnota = 11;
				else if (ln[1].charAt(0) == 'Q') hodnota = 12;
				else if (ln[1].charAt(0) == 'K') hodnota = 13;
				else if (ln[1].charAt(0) == 'A') hodnota = 14;
				else hodnota = Integer.parseInt(ln[1].charAt(0) + "");
				nova = new Karta(ln[1].charAt(1), hodnota);
				novy.druha = nova;

				setHracu.add(novy);
			}

			hraci(setHracu, stul);

		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
}
